/*
 * $Id: tmenuitm.prg,v 1.2 2000/06/03 08:38:41 vszel Exp $
 */

/*
 * Harbour Project source code:
 * MENUITEM class
 *
 * Copyright 2000 Jose Lalin <dezac@corevia.com>
 * www - http://www.harbour-project.org
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version, with one exception:
 *
 * The exception is that if you link the Harbour Runtime Library (HRL)
 * and/or the Harbour Virtual Machine (HVM) with other files to produce
 * an executable, this does not by itself cause the resulting executable
 * to be covered by the GNU General Public License. Your use of that
 * executable is in no way restricted on account of linking the HRL
 * and/or HVM code into it.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA (or visit
 * their web site at http://www.gnu.org/).
 *
 */

#include "common.ch"
#include "button.ch"
#include "hbsetup.ch"

#ifdef HB_COMPAT_C53

//--------------------------------------------------------------------------//
function MenuItem( cCaption, boData, nShortcut, cMsg, nID )

   LOCAL oClass

   if ISBLOCK( boData ) .or. ISOBJECT( boData )
      boData := iif( cCaption != MENU_SEPARATOR, boData, nil )
   endif

   DEFAULT cCaption  TO ""
   DEFAULT boData    TO nil
   DEFAULT nShortcut TO 0
   DEFAULT cMsg      TO ""
   DEFAULT nID       TO 0

   oClass := TClass():New( "MENUITEM" )

   oClass:AddData( "caption"  ,  cCaption )
   oClass:AddData( "cargo" )
   oClass:AddData( "checked"  ,  FALSE )
   oClass:AddData( "column"   ,  0 )
   oClass:AddData( "data"     ,  boData )
   oClass:AddData( "enabled"  ,  iif( cCaption != MENU_SEPARATOR, TRUE, FALSE ) )
   oClass:AddData( "id"       ,  nID )
   oClass:AddData( "message"  ,  cMsg )
   oClass:AddData( "row"      ,  0 )
   oClass:AddData( "shortcut" ,  nShortcut )
   oClass:AddData( "style"    ,  HB_TMENUITEM_STYLE )

   oClass:AddMethod( "isPopup",  @isPopup() )

   oClass:Create()

return oClass:Instance()

//--------------------------------------------------------------------------//
static function isPopUp()

   LOCAL Self  := QSelf()

   if ISOBJECT( ::data ) .and. ::data:ClassName() == "POPUPMENU"
      return TRUE
   endif

return FALSE

//--------------------------------------------------------------------------//

#endif
